long WINAPI CopyDialogProc(HANDLE hDlg,int Msg,int Param1,long Param2)
{
  FarDialogItem DialogItemSrc,DialogItemDst;
  FarDialogItemData Caption1,Caption2,Caption3;
  switch(Msg)
  {
    case DN_INITDIALOG:
      Info.SendDlgMessage(hDlg,DM_SETDLGDATA,0,Param2);
      Info.SendDlgMessage(hDlg,DM_SETTEXTLENGTH,2,MAX_PATH-1);
    case DN_BTNCLICK:
      struct CopyDialogData *dialog_data;
      dialog_data=(struct CopyDialogData *)Info.SendDlgMessage(hDlg,DM_GETDLGDATA,0,0);
      Info.SendDlgMessage(hDlg,DM_GETDLGITEM,6,(long)&DialogItemSrc);
      Info.SendDlgMessage(hDlg,DM_GETDLGITEM,11,(long)&DialogItemDst);
      if(DialogItemSrc.Selected)
      {
        if(!(DialogItemDst.Flags&DIF_DISABLE))
          dialog_data->DstRO=DialogItemDst.Selected;
        DialogItemDst.Selected=FALSE;
        DialogItemDst.Flags|=DIF_DISABLE;
      }
      else
      {
        if(DialogItemDst.Flags&DIF_DISABLE)
          DialogItemDst.Selected=dialog_data->DstRO;
        DialogItemDst.Flags&=~DIF_DISABLE;
      }
      Info.SendDlgMessage(hDlg,DM_SETDLGITEM,11,(long)&DialogItemDst);

      Info.SendDlgMessage(hDlg,DM_GETDLGITEM,8,(long)&DialogItemSrc);
      Info.SendDlgMessage(hDlg,DM_GETDLGITEM,10,(long)&DialogItemDst);
      if(DialogItemSrc.Selected)
      {
        if(DialogItemDst.Flags&DIF_DISABLE)
          DialogItemDst.Selected=dialog_data->SrcRO;
        DialogItemDst.Flags&=~DIF_DISABLE;
      }
      else
      {
        if(!(DialogItemDst.Flags&DIF_DISABLE))
          dialog_data->SrcRO=DialogItemDst.Selected;
        DialogItemDst.Selected=FALSE;
        DialogItemDst.Flags|=DIF_DISABLE;
      }
      Info.SendDlgMessage(hDlg,DM_SETDLGITEM,10,(long)&DialogItemDst);
      if(DialogItemSrc.Selected)
      {
        Caption1.PtrData=(char *)GetMsg(mCpyDlgMoveTitle);
        Caption1.PtrLength=strlen(Caption1.PtrData);
        Caption2.PtrData=dialog_data->MoveMessage;
        Caption2.PtrLength=strlen(Caption2.PtrData);
        Caption3.PtrData=(char *)GetMsg(mCpyDlgOkMove);
        Caption3.PtrLength=strlen(Caption3.PtrData);
      }
      else
      {
        Caption1.PtrData=(char *)GetMsg(mCpyDlgCopyTitle);
        Caption1.PtrLength=strlen(Caption1.PtrData);
        Caption2.PtrData=dialog_data->CopyMessage;
        Caption2.PtrLength=strlen(Caption2.PtrData);
        Caption3.PtrData=(char *)GetMsg(mCpyDlgOkCopy);
        Caption3.PtrLength=strlen(Caption3.PtrData);
      }
      Info.SendDlgMessage(hDlg,DM_SETTEXT,0,(long)&Caption1);
      Info.SendDlgMessage(hDlg,DM_SETTEXT,1,(long)&Caption2);
      Info.SendDlgMessage(hDlg,DM_SETTEXT,14,(long)&Caption3);
      break;
  }
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}

long WINAPI DelDialogProc(HANDLE hDlg,int Msg,int Param1,long Param2)
{
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}

long WINAPI AttrDialogProc(HANDLE hDlg,int Msg,int Param1,long Param2)
{
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}

long WINAPI WipeDialogProc(HANDLE hDlg,int Msg,int Param1,long Param2)
{
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}

long WINAPI Config1DialogProc(HANDLE hDlg,int Msg,int Param1,long Param2)
{
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}

long WINAPI Config2DialogProc(HANDLE hDlg,int Msg,int Param1,long Param2)
{
  switch(Msg)
  {
    case DN_BTNCLICK:
      if(Param1==20)
      {
        int fg=PlgOpt.ErrorColor&0x0F,bg=(PlgOpt.ErrorColor&0xF0)>>4;
        if(SelectColor(&fg,&bg))
        {
          PlgOpt.ErrorColor=fg|(bg<<4);
          HKEY hKey;
          DWORD Disposition;
          if((RegCreateKeyEx(HKEY_CURRENT_USER,PluginRootKey,0,NULL,0,KEY_WRITE,NULL,&hKey,&Disposition))==ERROR_SUCCESS)
          {
            RegSetValueEx(hKey,"TechErrorColor",0,REG_DWORD,(LPBYTE)&PlgOpt.ErrorColor,sizeof(PlgOpt.ErrorColor));
            RegCloseKey(hKey);
          }
        }
      }
      break;
  }
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}

long WINAPI PwdDialogProc(HANDLE hDlg,int Msg,int Param1,long Param2)
{
  switch(Msg)
  {
    case DN_INITDIALOG:
      Info.SendDlgMessage(hDlg,DM_SETTEXTLENGTH,1,255);
  }
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}

long WINAPI Config3DialogProc(HANDLE hDlg,int Msg,int Param1,long Param2)
{
  switch(Msg)
  {
    case DN_BTNCLICK:
      if((Param1==9)||(Param1==10))
      {
        if(!CheckPipeEx())
        {
          const char *MsgItems[]={GetMsg(mError),GetMsg(mErrorNoPipe),GetMsg(mOk)};
          Info.Message(Info.ModuleNumber,FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
          break;
        }
        char send[256+sizeof(DWORD)*3];
        DWORD *send_ptr=(DWORD *)send,send_size=sizeof(DWORD)*2;
        send_ptr[0]=OPERATION_PWD;
        if(Param1==9) //set password
        {
          send_ptr[1]=PWDFLAG_SET;
          struct FarDialogItem DialogItems[5]; int i=0;
          memset(DialogItems,0,sizeof(DialogItems));
          DialogItems[i].X1=3; DialogItems[i].X2=36; DialogItems[i].Y1=1; DialogItems[i].Y2=5;       //0
          DialogItems[i].Type=DI_DOUBLEBOX; strcpy(DialogItems[i].Data,GetMsg(mPwdTitle)); i++;
          DialogItems[i].X1=5; DialogItems[i].X2=34; DialogItems[i].Y1=2; DialogItems[i].Focus=1;    //1
          DialogItems[i].Type=DI_PSWEDIT; i++;
          DialogItems[i].X1=-1; DialogItems[i].Y1=3; DialogItems[i].Flags=DIF_SEPARATOR;             //2
          DialogItems[i].Type=DI_TEXT; i++;
          DialogItems[i].Y1=4; DialogItems[i].Flags=DIF_CENTERGROUP; DialogItems[i].DefaultButton=1; //3
          DialogItems[i].Type=DI_BUTTON; strcpy(DialogItems[i].Data,GetMsg(mPwdSet)); i++;
          DialogItems[i].Y1=4; DialogItems[i].Flags=DIF_CENTERGROUP;                                 //4
          DialogItems[i].Type=DI_BUTTON; strcpy(DialogItems[i].Data,GetMsg(mPwdCancel)); i++;
          int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,40,7,"Config4",DialogItems,(sizeof(DialogItems)/sizeof(DialogItems[0])),0,0,PwdDialogProc,0);
          if(DlgCode!=3) break;
          send_ptr[2]=strlen(DialogItems[1].Data)+1;
          send_size=send_ptr[2]+sizeof(DWORD)*3;
          strcpy(send+sizeof(DWORD)*3,DialogItems[1].Data);
        }
        else if(Param1==10) //set password
        {
          send_ptr[1]=PWDFLAG_CLEAR;
        }
        DWORD dwBytesRead,dwBytesWritten;
        HANDLE hPipe=CreateFile(PIPE_NAME,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
        DWORD error=0; BOOL Succ=FALSE;
        if(hPipe!=INVALID_HANDLE_VALUE)
        {
          if(WriteFile(hPipe,send_ptr,send_size,&dwBytesWritten,NULL))
            if(ReadFile(hPipe,&error,sizeof(error),&dwBytesRead,NULL))
              if(!error)
                Succ=TRUE;
          CloseHandle(hPipe);
        }
        if(Succ)
        {
          const char *MsgItems[]={"",GetMsg(mPwdCleared),GetMsg(mOk)};
          if(Param1==9)
            MsgItems[1]=GetMsg(mPwdSeted);
          Info.Message(Info.ModuleNumber,0,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
        }
        else
        {
          if(error) SetLastError(error);
          const char *MsgItems[]={GetMsg(mError),GetMsg(mOk)};
          Info.Message(Info.ModuleNumber,FMSG_ERRORTYPE|FMSG_WARNING,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
        }
      }
      break;
  }
  return Info.DefDlgProc(hDlg,Msg,Param1,Param2);
}
