#define LISTEN_THREADS_COUNT 16
extern void ServiceStop(void);
extern void ServiceStart(void);
extern BOOL ReportStatusToSCMgr(DWORD State,DWORD ExitCode,DWORD Wait);
extern DWORD WINAPI CopyThread(LPVOID lpvThreadParm);
extern DWORD WINAPI PrepareThread(LPVOID lpvThreadParm);
extern void Log(wchar_t *Func,wchar_t *parm1,wchar_t *parm2);
extern void LogSys(wchar_t *Func,wchar_t *parm1,wchar_t *parm2);
extern void LogAuditFail(void);

extern void InitInfo(void);
extern void FreeInfo(void);
extern void ResetStartEvent(void);
extern void WaitStartEvent(void);
extern void AddInfo(DWORD type,const wchar_t *Src,const wchar_t *SrcDir,const wchar_t *DestDir,BOOL InfoEx);
extern void DelInfo(void);
extern DWORD GetAllInfo(struct SmallInfoRec **GetInfo);
extern void GetInfo(DWORD ThreadId,struct InfoRec *GetInfo);
extern BOOL UpdateInfo(wchar_t *newSrc,wchar_t *newDest);
extern void SetStopInfo(DWORD ThreadId);
extern void SetPauseInfo(DWORD ThreadId);
extern BOOL SetStartInfo(unsigned long long size,unsigned int type);
extern BOOL UpdatePosInfo(unsigned long long add,unsigned long long subadd);
extern DWORD CheckErrorInfo(void);
extern void SetAllStopInfo(void);
extern void WaitForInfo(void);

extern DWORD GetMaxError(void);
extern DWORD GetThreadCount(void);
extern BOOL GetAllowNetwork(void);

extern void *DefaultTokenInformation(HANDLE token,TOKEN_INFORMATION_CLASS tic);

extern BOOL WipeFileW(wchar_t *filename);

DWORD __stdcall RtlNtStatusToDosError(long Status);
#define STATUS_OBJECT_NAME_NOT_FOUND ((long)0xC0000034L)
