static int Config()
{
  FarMenuItem MenuItems[3];
  memset(MenuItems,0,sizeof(MenuItems));
  int Msgs[]={mConfigMenu1,mConfigMenu2,mConfigMenu3};

  for(unsigned int i=0;i<sizeof(MenuItems)/sizeof(MenuItems[0]);i++)
  {
    MenuItems[i].Checked=MenuItems[i].Separator=0;
    strcpy(MenuItems[i].Text,GetMsg(Msgs[i]));
  };
  int MenuCode=0;
  while(TRUE)
  {
    for(unsigned int i=0;i<sizeof(MenuItems)/sizeof(MenuItems[0]);i++)
      MenuItems[i].Selected=0;
    MenuItems[MenuCode].Selected=TRUE;
    // Show menu
    MenuCode=Info.Menu(Info.ModuleNumber,-1,-1,0,FMENU_WRAPMODE,
                           GetMsg(mName),NULL,"Config",NULL,NULL,
                           MenuItems,sizeof(MenuItems)/sizeof(MenuItems[0]));
    if(MenuCode==-1)
      break;
    else if(MenuCode==0)
    {
      //Show dialog
      /*
        0000000000111111111122222222223333333333444444444455555555556666666666777777
        0123456789012345678901234567890123456789012345678901234567890123456789012345
      00                                                                            00
      01    Backgroung copy ͻ   01
      02    [ ] Use system copy history                                           02
      03    [ ] Show full info                                                    03
      04    Copy     04
      05    ( ) Overwrite all existing files                                      05
      06    ( ) Append to all existing files                                      06
      07    ( ) Skip all existing files                                           07
      08    ( ) Refresh old files                                                 08
      09                                                                          09
      10    [ ] Copy access rights                                                10
      11    [ ] Clear R/O attribute on &source                                    11
      12    [ ] Clear R/O attribute on &destination                               12
      13    [ ] Abort on error                                                    13
      15     Delete Ŀ    15
      16     [ ] Clear R/O attribute                                            16
      17     [ ] Abort on error                                                 17
      18        18
      19   Ķ   19
      20                    [ Save ]              [ Cancel ]                      20
      21   ͼ   21
      22                                                                            22
        0000000000111111111122222222223333333333444444444455555555556666666666777777
        0123456789012345678901234567890123456789012345678901234567890123456789012345
      */

      static struct InitDialogItem InitItems[]={
      /* 0*/  {DI_DOUBLEBOX,3,1,72,21,0,0,0,0,(char *)mName},
      /* 1*/  {DI_CHECKBOX,5,2,0,0,1,0,0,0,(char *)mConfigHistory},
      /* 2*/  {DI_CHECKBOX,5,3,0,0,0,0,0,0,(char *)mConfigFullInfo},

      /* 3*/  {DI_TEXT,-1,4,0,0,0,0,DIF_SEPARATOR,0,""},
      /* 4*/  {DI_RADIOBUTTON,5,5,0,0,0,0,DIF_GROUP,0,(char *)mCpyDlgOpt1},
      /* 5*/  {DI_RADIOBUTTON,5,6,0,0,0,0,0,0,(char *)mCpyDlgOpt2},
      /* 6*/  {DI_RADIOBUTTON,5,7,0,0,0,0,0,0,(char *)mCpyDlgOpt3},
      /* 7*/  {DI_RADIOBUTTON,5,8,0,0,0,0,0,0,(char *)mCpyDlgOpt4},
      /* 8*/  {DI_CHECKBOX,5,10,0,0,0,0,0,0,(char *)mCpyDlgChkAccess},
      /* 9*/  {DI_CHECKBOX,5,11,0,0,0,0,0,0,(char *)mCpyDlgChk2},
      /*10*/  {DI_CHECKBOX,5,12,0,0,0,0,0,0,(char *)mCpyDlgChk3},
      /*11*/  {DI_CHECKBOX,5,13,0,0,0,0,0,0,(char *)mCpyDlgChk4},

      /*12*/  {DI_TEXT,-1,14,0,0,0,0,DIF_SEPARATOR,0,""},
      /*13*/  {DI_CHECKBOX,5,15,0,0,0,0,0,0,(char *)mDelDlgChk1},
      /*14*/  {DI_CHECKBOX,5,16,0,0,0,0,0,0,(char *)mConfigDelAbort},

      /*15*/  {DI_TEXT,-1,17,0,0,0,0,DIF_SEPARATOR,0," Wipe "},
      /*16*/  {DI_CHECKBOX,5,18,0,0,0,0,0,0,(char *)mDelDlgChk1},
      /*17*/  {DI_TEXT,-1,19,0,0,0,0,DIF_SEPARATOR,0,""},
      /*18*/  {DI_BUTTON,0,20,0,0,0,0,DIF_CENTERGROUP,1,(char *)mConfigSave},
      /*19*/  {DI_BUTTON,0,20,0,0,0,0,DIF_CENTERGROUP,0,(char *)mConfigCancel}
      };

      struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
      InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]));

      strcpy(DialogItems[3].Data," ");
      strcat(DialogItems[3].Data,GetMsg(mCpyDlgCopyTitle));
      strcat(DialogItems[3].Data," ");
      strcpy(DialogItems[12].Data," ");
      strcat(DialogItems[12].Data,GetMsg(mDelDlgTitle));
      strcat(DialogItems[12].Data," ");
      DialogItems[1].Selected=Opt.CopyHistory;
      DialogItems[2].Selected=Opt.CopyFullInfo;
      DialogItems[4+Opt.CopyType].Selected=1;
      DialogItems[8].Selected=Opt.CopyAccess;
      DialogItems[9].Selected=Opt.CopyROSrc;
      DialogItems[10].Selected=Opt.CopyRODest;
      DialogItems[11].Selected=Opt.CopyAbort;

      DialogItems[13].Selected=Opt.DeleteRO;
      DialogItems[14].Selected=Opt.DeleteAbort;

      int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,76,23,"Config1",DialogItems,(sizeof(DialogItems)/sizeof(DialogItems[0])),0,0,Config1DialogProc,0);
      if(DlgCode==18)
      {
        Opt.CopyType=0;
        int i=4;
        while(!DialogItems[i].Selected) {i++; Opt.CopyType++;}
        Opt.CopyHistory=DialogItems[1].Selected;
        Opt.CopyFullInfo=DialogItems[2].Selected;
        Opt.CopyAccess=DialogItems[8].Selected;
        Opt.CopyROSrc=DialogItems[9].Selected;
        Opt.CopyRODest=DialogItems[10].Selected;
        Opt.CopyAbort=DialogItems[11].Selected;

        Opt.DeleteRO=DialogItems[13].Selected;
        Opt.DeleteAbort=DialogItems[14].Selected;

        HKEY hKey;
        DWORD Disposition;
        if((RegCreateKeyEx(HKEY_CURRENT_USER,PluginRootKey,0,NULL,0,KEY_WRITE,NULL,&hKey,&Disposition))==ERROR_SUCCESS)
        {
          RegSetValueEx(hKey,"CopyType",0,REG_DWORD,(LPBYTE)&Opt.CopyType,sizeof(Opt.CopyType));
          RegSetValueEx(hKey,"CopyHistory",0,REG_DWORD,(LPBYTE)&Opt.CopyHistory,sizeof(Opt.CopyHistory));
          RegSetValueEx(hKey,"CopyROSrc",0,REG_DWORD,(LPBYTE)&Opt.CopyROSrc,sizeof(Opt.CopyROSrc));
          RegSetValueEx(hKey,"CopyRODest",0,REG_DWORD,(LPBYTE)&Opt.CopyRODest,sizeof(Opt.CopyRODest));
          RegSetValueEx(hKey,"CopyAbort",0,REG_DWORD,(LPBYTE)&Opt.CopyAbort,sizeof(Opt.CopyAbort));
          RegSetValueEx(hKey,"CopyFullInfo",0,REG_DWORD,(LPBYTE)&Opt.CopyFullInfo,sizeof(Opt.CopyFullInfo));
          RegSetValueEx(hKey,"CopyAccess",0,REG_DWORD,(LPBYTE)&Opt.CopyAccess,sizeof(Opt.CopyAccess));
          RegSetValueEx(hKey,"DeleteRO",0,REG_DWORD,(LPBYTE)&Opt.DeleteRO,sizeof(Opt.DeleteRO));
          RegSetValueEx(hKey,"DeleteAbort",0,REG_DWORD,(LPBYTE)&Opt.DeleteAbort,sizeof(Opt.DeleteAbort));
          RegCloseKey(hKey);
        }
      }
    }
    else if(MenuCode==1)
    {
      //Show dialog
      /*
        0000000000111111111122222222223333333333444444444455555555556666666666777777
        0123456789012345678901234567890123456789012345678901234567890123456789012345
      00                                                                            00
      01    Backgroung copy ͻ   01
      02    [ ] &Autostart service                                                02
      03   Ķ   03
      04    [ ] Add to &Plugins menu                                              04
      05    [ ] Add to &Viewer menu                                               05
      06    [ ] Add to &Editor menu                                               06
      07    Info menu Ķ   07
      08    [ ] &Display message when job list is empty                           08
      09    [ ] Autoselect &only job                                              09
      10   Ķ   10
      11    [ ] Auto&show information dialog                                      11
      12    [ ] E&xpand variables in copy dialog                                  12
      13    [ ] Don't &check passive panel type                                   13
      14    [ ] &Format size                                                      14
      15    [ ] Show current time                                                 15
      16    [ ] Co&nfirm abort                                                    16
      17    [ ] Auto&refresh                                                      17
      18   Ķ   18
      19                    [ Save ]              [ Cancel ]                      19
      20   ͼ   20
      21                                                                            21
        0000000000111111111122222222223333333333444444444455555555556666666666777777
        0123456789012345678901234567890123456789012345678901234567890123456789012345
      */
      static struct InitDialogItem InitItems[]={
      /* 0*/  {DI_DOUBLEBOX,3,1,72,20,0,0,0,0,(char *)mName},
      /* 1*/  {DI_CHECKBOX,5,2,0,0,1,0,0,0,(char *)mConfigAutostart},
      /* 2*/  {DI_TEXT,-1,3,0,0,0,0,DIF_SEPARATOR,0,""},
      /* 3*/  {DI_CHECKBOX,5,4,0,0,0,0,0,0,(char *)mConfigConfigMenu},
      /* 4*/  {DI_CHECKBOX,5,5,0,0,0,0,0,0,(char *)mConfigViewerMenu},
      /* 5*/  {DI_CHECKBOX,5,6,0,0,0,0,0,0,(char *)mConfigEditorMenu},
      /* 6*/  {DI_TEXT,-1,7,0,0,0,0,DIF_SEPARATOR,0,""},
      /* 7*/  {DI_CHECKBOX,5,8,0,0,0,0,0,0,(char *)mConfigInfoEmpty},
      /* 8*/  {DI_CHECKBOX,5,9,0,0,0,0,0,0,(char *)mConfigInfoOnly},
      /* 9*/  {DI_TEXT,-1,10,0,0,0,0,DIF_SEPARATOR,0,""},
      /*10*/  {DI_CHECKBOX,5,11,0,0,0,0,0,0,(char *)mComfigAutoShowInfo},
      /*11*/  {DI_CHECKBOX,5,12,0,0,0,0,0,0,(char *)mConfigExpandVars},
      /*12*/  {DI_CHECKBOX,5,13,0,0,0,0,0,0,(char *)mConfigPassive},
      /*13*/  {DI_CHECKBOX,5,14,0,0,0,0,0,0,(char *)mConfigFormatSize},
      /*14*/  {DI_CHECKBOX,5,15,0,0,0,0,0,0,(char *)mConfigCurrentTime},
      /*15*/  {DI_CHECKBOX,5,16,0,0,0,0,0,0,(char *)mConfigConfirmAbort},
      /*16*/  {DI_CHECKBOX,5,17,0,0,0,0,0,0,(char *)mConfigAutoRefresh},
      /*17*/  {DI_TEXT,-1,18,0,0,0,0,DIF_SEPARATOR,0,""},
      /*18*/  {DI_BUTTON,0,19,0,0,0,0,DIF_CENTERGROUP,1,(char *)mConfigSave},
      /*19*/  {DI_BUTTON,0,19,0,0,0,0,DIF_CENTERGROUP,0,(char *)mConfigCancel},
      /*20*/  {DI_BUTTON,0,19,0,0,0,0,DIF_CENTERGROUP|DIF_BTNNOCLOSE,0,(char *)mColorMain}
      };
      struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
      InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]));
      DialogItems[1].Selected=PlgOpt.AutoStart;
      DialogItems[3].Selected=PlgOpt.ShowMenu&SHOW_IN_CONFIG;
      DialogItems[4].Selected=PlgOpt.ShowMenu&SHOW_IN_VIEWER;
      DialogItems[5].Selected=PlgOpt.ShowMenu&SHOW_IN_EDITOR;
      DialogItems[7].Selected=PlgOpt.InfoMenu&INFO_MENU_ALT_0;
      DialogItems[8].Selected=PlgOpt.InfoMenu&INFO_MENU_ALT_1;
      DialogItems[10].Selected=PlgOpt.AutoShowInfo;
      DialogItems[11].Selected=PlgOpt.ExpandVars;
      DialogItems[12].Selected=PlgOpt.CheckPassive;
      DialogItems[13].Selected=PlgOpt.FormatSize;
      DialogItems[14].Selected=PlgOpt.CurrentTime;
      DialogItems[15].Selected=PlgOpt.ConfirmAbort;
      DialogItems[16].Selected=PlgOpt.AutoRefresh;
      strcpy(DialogItems[6].Data," ");
      strcat(DialogItems[6].Data,GetMsg(mConfigInfo));
      strcat(DialogItems[6].Data," ");

      int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,76,22,"Config2",DialogItems,(sizeof(DialogItems)/sizeof(DialogItems[0])),0,0,Config2DialogProc,0);
      if(DlgCode==18)
      {
        PlgOpt.AutoStart=DialogItems[1].Selected;
        PlgOpt.ShowMenu=0;
        if(DialogItems[3].Selected)
          PlgOpt.ShowMenu|=SHOW_IN_CONFIG;
        if(DialogItems[4].Selected)
          PlgOpt.ShowMenu|=SHOW_IN_VIEWER;
        if(DialogItems[5].Selected)
          PlgOpt.ShowMenu|=SHOW_IN_EDITOR;
        PlgOpt.InfoMenu=0;
        if(DialogItems[7].Selected)
          PlgOpt.InfoMenu|=INFO_MENU_ALT_0;
        if(DialogItems[8].Selected)
          PlgOpt.InfoMenu|=INFO_MENU_ALT_1;
        PlgOpt.AutoShowInfo=DialogItems[10].Selected;
        PlgOpt.ExpandVars=DialogItems[11].Selected;
        PlgOpt.CheckPassive=DialogItems[12].Selected;
        PlgOpt.FormatSize=DialogItems[13].Selected;
        PlgOpt.CurrentTime=DialogItems[14].Selected;
        PlgOpt.ConfirmAbort=DialogItems[15].Selected;
        PlgOpt.AutoRefresh=DialogItems[16].Selected;
        HKEY hKey;
        DWORD Disposition;
        if((RegCreateKeyEx(HKEY_CURRENT_USER,PluginRootKey,0,NULL,0,KEY_WRITE,NULL,&hKey,&Disposition))==ERROR_SUCCESS)
        {
          RegSetValueEx(hKey,"TechAutoStart",0,REG_DWORD,(LPBYTE)&PlgOpt.AutoStart,sizeof(PlgOpt.AutoStart));
          RegSetValueEx(hKey,"TechShowMenu",0,REG_DWORD,(LPBYTE)&PlgOpt.ShowMenu,sizeof(PlgOpt.ShowMenu));
          RegSetValueEx(hKey,"TechInfoMenu",0,REG_DWORD,(LPBYTE)&PlgOpt.InfoMenu,sizeof(PlgOpt.InfoMenu));
          RegSetValueEx(hKey,"TechExpandVars",0,REG_DWORD,(LPBYTE)&PlgOpt.ExpandVars,sizeof(PlgOpt.ExpandVars));
          RegSetValueEx(hKey,"TechCheckPassive",0,REG_DWORD,(LPBYTE)&PlgOpt.CheckPassive,sizeof(PlgOpt.CheckPassive));
          RegSetValueEx(hKey,"TechFormatSize",0,REG_DWORD,(LPBYTE)&PlgOpt.FormatSize,sizeof(PlgOpt.FormatSize));
          RegSetValueEx(hKey,"TechAutoShowInfo",0,REG_DWORD,(LPBYTE)&PlgOpt.AutoShowInfo,sizeof(PlgOpt.AutoShowInfo));
          RegSetValueEx(hKey,"TechConfirmAbort",0,REG_DWORD,(LPBYTE)&PlgOpt.ConfirmAbort,sizeof(PlgOpt.ConfirmAbort));
          RegSetValueEx(hKey,"TechCurrentTime",0,REG_DWORD,(LPBYTE)&PlgOpt.CurrentTime,sizeof(PlgOpt.CurrentTime));
          RegSetValueEx(hKey,"TechAutoRefresh",0,REG_DWORD,(LPBYTE)&PlgOpt.AutoRefresh,sizeof(PlgOpt.AutoRefresh));
          RegCloseKey(hKey);
        }
      }
    }
    else if(MenuCode==2)
    {
      //Show dialog
      /*
        00000000001111111111222222222233333333334444444444555555555566666666667777777
        01234567890123456789012345678901234567890123456789012345678901234567890123456
      00                                                                             00
      01    Backgroung copy ͻ   01
      02    &Maximum errors per thread:                                          02
      03    &Number of listening threads:                                        03
      04    [ ] &Allow network connections to the pipe                             04
      05   Ķ   05
      06          [ Save ] [ Cancel ] [ Set password ] [ Clear password ]          06
      07   ͼ   07
      08                                                                             08
        00000000001111111111222222222233333333334444444444555555555566666666667777777
        01234567890123456789012345678901234567890123456789012345678901234567890123456
      */
      static struct InitDialogItem InitItems[]={
      /*00*/  {DI_DOUBLEBOX,3,1,73,7,0,0,0,0,(char *)mName},
      /*01*/  {DI_TEXT,5,2,0,0,0,0,0,0,(char *)mConfigMaxErrors},
      /*02*/  {DI_FIXEDIT,0,2,0,0,1,(int)"#####9",DIF_MASKEDIT,0,"20"},
      /*03*/  {DI_TEXT,5,3,0,0,0,0,0,0,(char *)mConfigThreadCount},
      /*04*/  {DI_FIXEDIT,0,3,0,0,1,(int)"#9",DIF_MASKEDIT,0," 4"},
      /*05*/  {DI_CHECKBOX,5,4,0,0,0,0,0,0,(char *)mConfigAllowNetwork},
      /*06*/  {DI_TEXT,-1,5,0,0,0,0,DIF_SEPARATOR,0,""},
      /*07*/  {DI_BUTTON,0,6,0,0,0,0,DIF_CENTERGROUP,1,(char *)mConfigSave},
      /*08*/  {DI_BUTTON,0,6,0,0,0,0,DIF_CENTERGROUP,0,(char *)mConfigCancel},
      /*09*/  {DI_BUTTON,0,6,0,0,0,0,DIF_CENTERGROUP|DIF_BTNNOCLOSE,0,(char *)mConfigSetPassword},
      /*10*/  {DI_BUTTON,0,6,0,0,0,0,DIF_CENTERGROUP|DIF_BTNNOCLOSE,0,(char *)mConfigClearPassword},
      };
      struct FarDialogItem DialogItems[sizeof(InitItems)/sizeof(InitItems[0])];
      InitDialogItems(InitItems,DialogItems,sizeof(InitItems)/sizeof(InitItems[0]));
      unsigned int max;
      max=strlen(DialogItems[1].Data);
      if(max<strlen(DialogItems[3].Data))
        max=strlen(DialogItems[3].Data);
      DialogItems[2].X1=DialogItems[1].X1+max; DialogItems[2].X2=DialogItems[2].X1+5;
      DialogItems[4].X1=DialogItems[3].X1+max+4; DialogItems[4].X2=DialogItems[4].X1+1;

      HKEY hKey; DWORD Type,DataSize; DWORD Value; DWORD Disposition;
      if((RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\"SVC_NAME"\\Parameters",0,KEY_QUERY_VALUE,&hKey))==ERROR_SUCCESS)
      {
        DataSize=sizeof(Value); Value=20;
        RegQueryValueEx(hKey,"MaxError",0,&Type,(LPBYTE)&Value,&DataSize);
        sprintf(DialogItems[2].Data,"%2ld",Value);
        DataSize=sizeof(Value); Value=4;
        RegQueryValueEx(hKey,"ThreadCount",0,&Type,(LPBYTE)&Value,&DataSize);
        if((Value>16)||(Value<1)) Value=4;
        sprintf(DialogItems[4].Data,"%2ld",Value);

        DataSize=sizeof(Value); Value=0;
        RegQueryValueEx(hKey,"AllowNetwork",0,&Type,(LPBYTE)&Value,&DataSize);
        DialogItems[5].Selected=Value;
      }
      int DlgCode=Info.DialogEx(Info.ModuleNumber,-1,-1,77,9,"Config3",DialogItems,(sizeof(DialogItems)/sizeof(DialogItems[0])),0,0,Config3DialogProc,0);
      if (DlgCode==7)
      {
        if((RegCreateKeyEx(HKEY_LOCAL_MACHINE,"SYSTEM\\CurrentControlSet\\Services\\"SVC_NAME"\\Parameters",0,NULL,0,KEY_WRITE,NULL,&hKey,&Disposition))==ERROR_SUCCESS)
        {
          Value=atoi(DialogItems[2].Data);
          RegSetValueEx(hKey,"MaxError",0,REG_DWORD,(LPBYTE)&Value,sizeof(Value));
          Value=atoi(DialogItems[4].Data); if((Value<1)||(Value>16)) Value=4;
          RegSetValueEx(hKey,"ThreadCount",0,REG_DWORD,(LPBYTE)&Value,sizeof(Value));
          Value=DialogItems[5].Selected;
          RegSetValueEx(hKey,"AllowNetwork",0,REG_DWORD,(LPBYTE)&Value,sizeof(Value));
          RegCloseKey(hKey);
        }
        {
          const char *MsgItems[]={"",GetMsg(mActualize),GetMsg(mOk)};
          Info.Message(Info.ModuleNumber,0,NULL,MsgItems,sizeof(MsgItems)/sizeof(MsgItems[0]),1);
        }
      }
    }
  }
  return FALSE;
}
